/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/


//#include <stdio.h>
#include <qtimer.h>
#include <qslider.h>
#include <qmessagebox.h>

///usbmヘッダー
#include <WinTypes.h>
#include <USBM3069.h>

///******************************************************************************
///　変数定義
static int button_test = 0;	///　ボタンのコントロール ０：接続済み　１：未接続
static int bord_input = 0;	///　ボードの入力値 (グローバルで共通に使うデータ)
static long count32_ary[4];	///　32ビットパルスカウンタ用バッファ

///　デジタル出力用バタン値
static BYTE pat_dgout[] =
    { 0x81, 0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x81, 0x0 };
///　７セグ用バタン値
static BYTE pat_7seg[] =
    { 0x3f, 0x6, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x27, 0x7f, 0x6f, 0x80 };

static QTimer *counter = NULL;	///　タイマーの定義

static TW_HANDLE handle0 = NULL;	///　ハンドルの定義

///　16ビットタイマPWM用スライダーの数値表示
void usbm3069::pwm16_slider0_valueChanged(int)	///　スライダー0
{
    QString slider0text;
    slider0text.sprintf(" %d ", pwm16_slider0->value());
    pwm16_label0->setText(slider0text);
}


void usbm3069::pwm16_slider1_valueChanged(int)	///　スライダー1
{
    QString slider1text;
    slider1text.sprintf(" %d ", pwm16_slider1->value());
    pwm16_label1->setText(slider1text);
}


void usbm3069::pwm16_slider2_valueChanged(int)	///　スライダー2
{
    QString slider2text;
    slider2text.sprintf(" %d ", pwm16_slider2->value());
    pwm16_label2->setText(slider2text);
}

///********************************************************************************
///********************************************************************************
///　接続ボタンをクリックしたとき
void usbm3069::connect_button_clicked()
{
    ///　ボードを初期化する  
    handle0 = USBM_Open(NULL);	///　ハンドルを開く

    if (handle0 != NULL)	///　ハンドル成功の場合
    {
	USBM_Initialize(handle0);	/// 　初期化を行う
	USBM_AddressEnable(handle0, 16);	///　アドレスを16ビット有効にする
	///　ボタンの状態を変更する      
	connect_button->setEnabled(FALSE);
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);

	counter = new QTimer();	///　タイマーの作成
    } else			///　ハンドル失敗の場合
    {

	///　接続失敗の警告
	QMessageBox::critical(this, QString::fromUtf8("接続"),
			      QString::fromUtf8
			      ("USB3069との接続に失敗しました"),
			      "OK");
    }
}

///********************************************************************************
///　切断ボタンをクリックしたとき
void usbm3069::cut_button_clicked()
{
    ///　ボタンの状態を変更する 
    connect_button->setEnabled(TRUE);
    cut_button->setEnabled(FALSE);
    digitalin_button->setEnabled(FALSE);
    digitalout_button->setEnabled(FALSE);
    bus8_button->setEnabled(FALSE);
    adin_button->setEnabled(FALSE);
    daout_button->setEnabled(FALSE);
    pwm16_button->setEnabled(FALSE);
    count16_button->setEnabled(FALSE);
    count32_button->setEnabled(FALSE);
    delete counter;		///　タイマーを破棄する
    counter = NULL;
    ///　ハンドルを閉める
    USBM_Close(handle0);
    handle0 = NULL;

}

///********************************************************************************
///　ダイアログ破棄される時に行う処理
void usbm3069::destroy()
{
    if (handle0 != NULL) {
	delete counter;		///　タイマーを破棄する
	counter = NULL;
	///　ハンドルを閉める
	USBM_Close(handle0);
	handle0 = NULL;

    }
}

///********************************************************************************
///　デジタル入力ボタンをクリックしたとき
void usbm3069::digitalin_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  デジタル入力ボタンを変更する
	digitalin_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	digitalin_button->setPalette(QColor(255, 0, 0));
	digitalin_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_dgin()));
	counter->start(100);	///　タイマースタート 

    } else			///　停止の場合
    {
	///  デジタル入力ボタンを変更する
	digitalin_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	digitalin_button->setPalette(QColor(230, 230, 230));
	digitalin_button->setText(QString::fromUtf8("デジタル入力"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを０に

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_dgin()));

    }
}

///********************************************************************************
///　デジタル出力ボタンをクリックしたとき
void usbm3069::digitalout_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  デジタル出力ボタンを変更する
	digitalout_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	digitalout_button->setPalette(QColor(255, 0, 0));
	digitalout_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_dgout()));
	counter->start(100);	///　タイマースタート


    } else			///　停止の場合
    {
	///  デジタル出力ボタンを変更する
	digitalout_button->
	    setPaletteBackgroundColor(QColor(230, 230, 230));
	digitalout_button->setPalette(QColor(230, 230, 230));
	digitalout_button->
	    setText(QString::fromUtf8("デジタル出力"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_dgout()));


	bord_input = 0;		///　グローバルデータを元に戻す
    }
}

///********************************************************************************
/// 8ビットバス7セグ表式ボタンクリックしたとき
void usbm3069::bus8_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  8ビットバス7セグ表式ボタンを変更する
	bus8_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	bus8_button->setPalette(QColor(255, 0, 0));
	bus8_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_7seg()));
	counter->start(100);	///　タイマースタート

    } else			///　停止の場合
    {
	///  8ビットバス7セグ表式ボタンを変更する
	bus8_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	bus8_button->setPalette(QColor(230, 230, 230));
	bus8_button->
	    setText(QString::fromUtf8("8ビットバス\n7セグ表式"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_7seg()));


	bord_input = 0;		///　グローバルデータを元に戻す
    }
}

///********************************************************************************
/// ADコンバータ入力ボタンをクリックしたとき
void usbm3069::adin_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  ADコンバータ入力ボタンを変更する
	adin_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	adin_button->setPalette(QColor(255, 0, 0));
	adin_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_adin()));
	counter->start(1000);	///　タイマースタート

    } else			///　停止の場合
    {
	///  ADコンバータ入力ボタンを変更する
	adin_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	adin_button->setPalette(QColor(230, 230, 230));
	adin_button->
	    setText(QString::fromUtf8("ADコンバータ\n入力"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_adin()));


	bord_input = 0;		///　グローバルデータを元に戻す
    }
}

///********************************************************************************
///　DAコンバータ出力ボタンをクリックしたとき
void usbm3069::daout_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  DAコンバータ出力ボタンを変更する
	daout_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	daout_button->setPalette(QColor(255, 0, 0));
	daout_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_daout()));
	counter->start(100);	///　タイマースタート

    } else			///　停止の場合
    {
	///  DAコンバータ出力ボタンを変更する
	daout_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	daout_button->setPalette(QColor(230, 230, 230));
	daout_button->
	    setText(QString::fromUtf8("DAコンバータ\n出力"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_daout()));


	bord_input = 0;		///　グローバルデータを元に戻す
    }
}

///********************************************************************************
/// 16ビットタイマPWMボタンをクリックしたとき
void usbm3069::pwm16_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  16ビットタイマPWMボタンを変更する
	pwm16_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	pwm16_button->setPalette(QColor(255, 0, 0));
	pwm16_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	///　12.5MHzのクロックを選択
	USBM_TimerSetClk(handle0, 0, USBM_TCLK12500);
	USBM_TimerSetClk(handle0, 1, USBM_TCLK12500);
	USBM_TimerSetClk(handle0, 2, USBM_TCLK12500);
	///　カウンタ初期値
	USBM_TimerSetCnt(handle0, 0, 0);
	USBM_TimerSetCnt(handle0, 1, 0);
	USBM_TimerSetCnt(handle0, 2, 0);

	USBM_TimerSetLevel(handle0, 0x15);	/// チァンネル0,1,2の初期値を1にする
	USBM_TimerEnable(handle0, 0x7, 0);	///　チァンネル0,1,3を出力
	USBM_TimerStart(handle0, 0x7);	///　チァンネル0,1を開始
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_pwm16()));
	counter->start(100);	///　タイマースタート

    } else			///　停止の場合
    {
	///  16ビットタイマPWMボタンを変更する
	pwm16_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	pwm16_button->setPalette(QColor(230, 230, 230));
	pwm16_button->
	    setText(QString::fromUtf8("16ビットタイマ\nPWM"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	USBM_TimerStart(handle0, 0x0);	///　チァンネルを停止
	USBM_TimerEnable(handle0, 0x0, 0);	///　チァンネル0,1,3を出力停止

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_pwm16()));

    }
}

///********************************************************************************
///　16ビットタイマ2相パルス計数ボタンをクリックしたとき
void usbm3069::count16_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  16ビットタイマ2相パルス計数ボタンを変更する
	count16_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	count16_button->setPalette(QColor(255, 0, 0));
	count16_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count32_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に

	USBM_TimerEnable(handle0, 0, 1);	/// チァンネル2を相位計数モードに設定
	USBM_TimerSetCnt(handle0, 2, 0);	///　タイマ2をクリア
	USBM_TimerStart(handle0, 0x4);	///　カウント開始
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_count16()));
	counter->start(200);	///　タイマースタート

    } else			///　停止の場合
    {
	///  16ビットタイマ2相パルス計数ボタンを変更する
	count16_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	count16_button->setPalette(QColor(230, 230, 230));
	count16_button->
	    setText(QString::fromUtf8
		    ("16ビットタイマ\n2相パルス計数"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count32_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に

	USBM_TimerStart(handle0, 0x0);	///　カウント停止

	counter->stop();	///　タイマーを停止する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_count16()));
	///　タイマーをボードの実行する関数の関連を解除する


	bord_input = 0;		///　グローバルデータを元に戻す
    }
}

///********************************************************************************
/// 32ビットパルスカウンタボタンをクリックしたとき
void usbm3069::count32_button_clicked()
{
    if (button_test < 1)	///　開始の場合
    {
	///  32ビットパルスカウンタボタンを変更する
	count32_button->setPaletteBackgroundColor(QColor(255, 0, 0));
	count32_button->setPalette(QColor(255, 0, 0));
	count32_button->setText(QString("STOP"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(FALSE);
	digitalin_button->setEnabled(FALSE);
	digitalout_button->setEnabled(FALSE);
	bus8_button->setEnabled(FALSE);
	adin_button->setEnabled(FALSE);
	daout_button->setEnabled(FALSE);
	pwm16_button->setEnabled(FALSE);
	count16_button->setEnabled(FALSE);
	button_test++;		///　表示スイッチを１に
	/// 初期化する
	USBM_PortWrite8(handle0, USBM_POUT, 0xFF);
	/// PC0~PC4 = 0
	USBM_PCSetCnt(handle0, 0, 0);
	USBM_PCSetCnt(handle0, 1, 0);
	USBM_PCSetCnt(handle0, 2, 0);
	USBM_PCSetCnt(handle0, 3, 0);
	/// コンディションビットによる加算、減算の設定
	USBM_PCSetControl(handle0, 0, 0x0);
	USBM_PCSetControl(handle0, 1, 0x0);
	USBM_PCSetControl(handle0, 2, 0x0);
	USBM_PCSetControl(handle0, 3, 0x0);
	///　計数を開始
	USBM_PCStart(handle0, (USBM_PC0 | USBM_PC1 | USBM_PC2 | USBM_PC3));
	///　タイマーをボードの実行する関数に関連する
	connect(counter, SIGNAL(timeout()), this, SLOT(disp_count32()));
	counter->start(100);	///　タイマースタート


    } else			///　停止の場合
    {
	///  32ビットパルスカウンタボタンを変更する
	count32_button->setPaletteBackgroundColor(QColor(230, 230, 230));
	count32_button->setPalette(QColor(230, 230, 230));
	count32_button->
	    setText(QString::fromUtf8
		    ("32ビット\nパルスカウンタ"));
	///　ボタンの状態を変更する
	cut_button->setEnabled(TRUE);
	digitalin_button->setEnabled(TRUE);
	digitalout_button->setEnabled(TRUE);
	bus8_button->setEnabled(TRUE);
	adin_button->setEnabled(TRUE);
	daout_button->setEnabled(TRUE);
	pwm16_button->setEnabled(TRUE);
	count16_button->setEnabled(TRUE);
	button_test--;		///　表示スイッチを0に
	///　計数を停止
	USBM_PCStart(handle0, 0);

	counter->stop();	///　タイマーを停止する
	///　タイマーをボードの実行する関数の関連を解除する
	disconnect(counter, SIGNAL(timeout()), this, SLOT(disp_count32()));


	bord_input = 0;		///グローバルデータを元に戻す
    }
}



/***********************************************************************************
***********************************************************************************


                                タイマー用のスロット


***********************************************************************************
**********************************************************************************/

///********************************************************************************
///********************************************************************************
///  デジタル入力
void usbm3069::disp_dgin()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data;		///　読み込み用変数

	USBM_PortRead8(handle, USBM_P4, &data);	///　デジタル入力を行う
	/// デジタル入力値を表示する
	if (data & 0x1)
	    digitalin_checkbox1->setChecked(TRUE);
	else
	    digitalin_checkbox1->setChecked(FALSE);
	if (data & 0x2)
	    digitalin_checkbox2->setChecked(TRUE);
	else
	    digitalin_checkbox2->setChecked(FALSE);
	if (data & 0x4)
	    digitalin_checkbox3->setChecked(TRUE);
	else
	    digitalin_checkbox3->setChecked(FALSE);
	if (data & 0x8)
	    digitalin_checkbox4->setChecked(TRUE);
	else
	    digitalin_checkbox4->setChecked(FALSE);
	if (data & 0x10)
	    digitalin_checkbox5->setChecked(TRUE);
	else
	    digitalin_checkbox5->setChecked(FALSE);
	if (data & 0x20)
	    digitalin_checkbox6->setChecked(TRUE);
	else
	    digitalin_checkbox6->setChecked(FALSE);
	if (data & 0x40)
	    digitalin_checkbox7->setChecked(TRUE);
	else
	    digitalin_checkbox7->setChecked(FALSE);
	if (data & 0x80)
	    digitalin_checkbox8->setChecked(TRUE);
	else
	    digitalin_checkbox8->setChecked(FALSE);
    }
}

///********************************************************************************
///  デジタル出力
void usbm3069::disp_dgout()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data;		///書き込み用変数
	/// カウンタ値からバタン値を決定する
	if (bord_input > 8)
	    bord_input = 0;
	data = pat_dgout[bord_input];
	/// バタン値を出力する
	USBM_PortWrite8(handle, USBM_POUT, data);
	///　デジタル出力の表示（デジタル出力グループ）
	if (data & 0x1)
	    digitalout_checkbox0->setChecked(TRUE);
	else
	    digitalout_checkbox0->setChecked(FALSE);
	if (data & 0x2)
	    digitalout_checkbox1->setChecked(TRUE);
	else
	    digitalout_checkbox1->setChecked(FALSE);
	if (data & 0x4)
	    digitalout_checkbox2->setChecked(TRUE);
	else
	    digitalout_checkbox2->setChecked(FALSE);
	if (data & 0x8)
	    digitalout_checkbox3->setChecked(TRUE);
	else
	    digitalout_checkbox3->setChecked(FALSE);
	if (data & 0x10)
	    digitalout_checkbox4->setChecked(TRUE);
	else
	    digitalout_checkbox4->setChecked(FALSE);
	if (data & 0x20)
	    digitalout_checkbox5->setChecked(TRUE);
	else
	    digitalout_checkbox5->setChecked(FALSE);
	if (data & 0x40)
	    digitalout_checkbox6->setChecked(TRUE);
	else
	    digitalout_checkbox6->setChecked(FALSE);
	if (data & 0x80)
	    digitalout_checkbox7->setChecked(TRUE);
	else
	    digitalout_checkbox7->setChecked(FALSE);
	///　デジタル出力の表示（16ビットタイマ2相パルス計数グループ）
	if (data & 0x10)
	    count16_checkbox4->setChecked(TRUE);
	else
	    count16_checkbox4->setChecked(FALSE);
	if (data & 0x20)
	    count16_checkbox5->setChecked(TRUE);
	else
	    count16_checkbox5->setChecked(FALSE);
	///　デジタル出力の表示（32ビットパルスカウンタグループ）
	if (data & 0x1)
	    count32_checkbox0->setChecked(TRUE);
	else
	    count32_checkbox0->setChecked(FALSE);
	if (data & 0x2)
	    count32_checkbox1->setChecked(TRUE);
	else
	    count32_checkbox1->setChecked(FALSE);
	if (data & 0x4)
	    count32_checkbox2->setChecked(TRUE);
	else
	    count32_checkbox2->setChecked(FALSE);
	if (data & 0x8)
	    count32_checkbox3->setChecked(TRUE);
	else
	    count32_checkbox3->setChecked(FALSE);

	bord_input++;		///　カウンタ値を更新する 
    }
}

///********************************************************************************
//　７セグ出力
void usbm3069::disp_7seg()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data1, data2;	///　表示用変数
	/// カウンタ値からバタン値を決定する
	data1 = pat_7seg[bord_input / 10];
	data2 = pat_7seg[bord_input % 10];
	///　ピリオドを表示する処理
	if ((bord_input % 10) < 5)
	    data2 |= pat_7seg[10];
	else
	    data1 |= pat_7seg[10];
	///　バタン値を出力する       
	USBM_PortWrite8(handle, USBM_AREA5_TOP + 1, data1);
	USBM_PortWrite8(handle, USBM_AREA5_TOP + 2, data2);
	///　バタン値を画面に反映する      
	QString seg7text;
	seg7text.sprintf("%02d", bord_input);
	bus8_label->setText(seg7text);
	///　カウンタ値を更新する
	if (bord_input < 99)
	    bord_input++;
	else
	    bord_input = 0;
    }
}

///********************************************************************************
///　AD入力
void usbm3069::disp_adin()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data1, data2;	///　DA用変数
	/// カウンタ値からDA出力値を決定する
	if (bord_input > 509)
	    bord_input = 0;
	if (bord_input <= 255)
	    data1 = (BYTE) bord_input;
	else
	    data1 = (BYTE) (510 - bord_input);
	data2 = 255 - data1;
	///　DA出力を行う
	USBM_PortWrite8(handle, USBM_DA0, data1);
	USBM_PortWrite8(handle, USBM_DA1, data2);
	///　DA出力値を画面に反映する
	QString da0text;
	da0text.sprintf("%02X", data1);
	adin_da0_label->setText(da0text);
	daout_label0->setText(da0text);
	daout_progressbar0->setProgress(data1);
	QString da1text;
	da1text.sprintf("%02X", data2);
	adin_da1_label->setText(da1text);
	daout_label1->setText(da1text);
	daout_progressbar1->setProgress(data2);
	///　AD入力を行う
	WORD addata[4];
	USBM_ADRead(handle, addata, 3, 1);
	///　AD値を画面に表示する
	QString ad0text;
	ad0text.sprintf("%04X", addata[0]);
	adin_ad0_label->setText(ad0text);
	QString ad1text;
	ad1text.sprintf("%04X", addata[1]);
	adin_ad1_label->setText(ad1text);
	QString ad2text;
	ad2text.sprintf("%04X", addata[2]);
	adin_ad2_label->setText(ad2text);
	QString ad3text;
	ad3text.sprintf("%04X", addata[3]);
	adin_ad3_label->setText(ad3text);
	///　カウンタ値を更新する
	bord_input = bord_input + 10;
    }
}

///********************************************************************************
///　DA出力
void usbm3069::disp_daout()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data1, data2;	///　DA用変数
	/// カウンタ値からDA出力値を決定する
	if (bord_input > 509)
	    bord_input = 0;
	if (bord_input <= 255)
	    data1 = (BYTE) bord_input;
	else
	    data1 = (BYTE) (510 - bord_input);
	data2 = 255 - data1;
	///　DA出力を行う
	USBM_PortWrite8(handle, USBM_DA0, data1);
	USBM_PortWrite8(handle, USBM_DA1, data2);
	///　DA出力値を画面に反映する
	QString da_0text;
	da_0text.sprintf("%02X", data1);
	adin_da0_label->setText(da_0text);
	daout_label0->setText(da_0text);
	daout_progressbar0->setProgress(data1);
	QString da_1text;
	da_1text.sprintf("%02X", data2);
	adin_da1_label->setText(da_1text);
	daout_label1->setText(da_1text);
	daout_progressbar1->setProgress(data2);
	///　カウンタ値を更新する
	bord_input = bord_input + 5;
    }
}

///********************************************************************************
///　PWM出力
void usbm3069::disp_pwm16()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	short data;		///　DA変数の定義
	/// カウンタ値からDA出力値を決定する
	data = 10000 - (pwm16_slider0->value() * 100);
	USBM_TimerSetPulse(handle, 0, data, 9999);
	data = 10000 - (pwm16_slider1->value() * 100);
	USBM_TimerSetPulse(handle, 1, data, 9999);
	data = 10000 - (pwm16_slider2->value() * 100);
	USBM_TimerSetPulse(handle, 2, data, 9999);
    }
}

///********************************************************************************
///　2相パルス計数
void usbm3069::disp_count16()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data1 = 0x0;	///　出力用変数
	short data2;		/// パルスカウンタ用変数
	int check;
	/// カウンタ値からDA出力値を決定する
	if (bord_input < 0)
	    bord_input = 3;
	if (bord_input > 3)
	    bord_input = 0;

	switch (bord_input) {
	case 0:		///　POUT4=0, POUT5=0
	    data1 = 0x0;
	    break;
	case 1:		///　POUT4=1, POUT5=0
	    data1 = 0x20;
	    break;
	case 2:		///　POUT4=1, POUT5=1
	    data1 = 0x30;
	    break;
	case 3:		///　POUT4=0, POUT5=1
	    data1 = 0x10;
	    break;
	}
	///　デジタル出力行う
	USBM_PortWrite8(handle, USBM_POUT, data1);
	///　デジタル出力の表示（デジタル出力グループ）
	if (data1 & 0x1)
	    digitalout_checkbox0->setChecked(TRUE);
	else
	    digitalout_checkbox0->setChecked(FALSE);
	if (data1 & 0x2)
	    digitalout_checkbox1->setChecked(TRUE);
	else
	    digitalout_checkbox1->setChecked(FALSE);
	if (data1 & 0x4)
	    digitalout_checkbox2->setChecked(TRUE);
	else
	    digitalout_checkbox2->setChecked(FALSE);
	if (data1 & 0x8)
	    digitalout_checkbox3->setChecked(TRUE);
	else
	    digitalout_checkbox3->setChecked(FALSE);
	if (data1 & 0x10)
	    digitalout_checkbox4->setChecked(TRUE);
	else
	    digitalout_checkbox4->setChecked(FALSE);
	if (data1 & 0x20)
	    digitalout_checkbox5->setChecked(TRUE);
	else
	    digitalout_checkbox5->setChecked(FALSE);
	if (data1 & 0x40)
	    digitalout_checkbox6->setChecked(TRUE);
	else
	    digitalout_checkbox6->setChecked(FALSE);
	if (data1 & 0x80)
	    digitalout_checkbox7->setChecked(TRUE);
	else
	    digitalout_checkbox7->setChecked(FALSE);
	///　デジタル出力の表示（16ビットタイマ2相パルス計数グループ）
	if (data1 & 0x10)
	    count16_checkbox4->setChecked(TRUE);
	else
	    count16_checkbox4->setChecked(FALSE);
	if (data1 & 0x20)
	    count16_checkbox5->setChecked(TRUE);
	else
	    count16_checkbox5->setChecked(FALSE);
	///　デジタル出力の表示（32ビットパルスカウンタグループ）
	if (data1 & 0x1)
	    count32_checkbox0->setChecked(TRUE);
	else
	    count32_checkbox0->setChecked(FALSE);
	if (data1 & 0x2)
	    count32_checkbox1->setChecked(TRUE);
	else
	    count32_checkbox1->setChecked(FALSE);
	if (data1 & 0x4)
	    count32_checkbox2->setChecked(TRUE);
	else
	    count32_checkbox2->setChecked(FALSE);
	if (data1 & 0x8)
	    count32_checkbox3->setChecked(TRUE);
	else
	    count32_checkbox3->setChecked(FALSE);
	///　パルスカウンタ値の読み出す
	USBM_TimerReadCnt(handle, 2, &data2);
	///　パルスカウンタ値を表示する
	QString count16text = QString::number(data2, 10);
	count16_label->setText(count16text);
	///　回転方向によるカウンタ値を更新を行う
	check = count16_radiobutton4->isChecked();
	if (check > 0)
	    bord_input++;	///　正転
	else
	    bord_input--;	///　反転
    }
}

///********************************************************************************
/// 32ビットパルスカウンタ
void usbm3069::disp_count32()
{
    TW_HANDLE handle;		///　ハンドルを取得
    handle = handle0;

    if (handle) {
	BYTE data;		///　DA用変数
	/// カウンタ値からDA出力値を決定する
	if (bord_input < 0 || bord_input > 15)
	    bord_input = 0;
	data = (BYTE) (15 - bord_input);
	///　デジタル出力をする
	USBM_PortWrite8(handle, USBM_POUT, data);
	///　デジタル出力の表示（デジタル出力グループ）
	if (data & 0x1)
	    digitalout_checkbox0->setChecked(TRUE);
	else
	    digitalout_checkbox0->setChecked(FALSE);
	if (data & 0x2)
	    digitalout_checkbox1->setChecked(TRUE);
	else
	    digitalout_checkbox1->setChecked(FALSE);
	if (data & 0x4)
	    digitalout_checkbox2->setChecked(TRUE);
	else
	    digitalout_checkbox2->setChecked(FALSE);
	if (data & 0x8)
	    digitalout_checkbox3->setChecked(TRUE);
	else
	    digitalout_checkbox3->setChecked(FALSE);
	if (data & 0x10)
	    digitalout_checkbox4->setChecked(TRUE);
	else
	    digitalout_checkbox4->setChecked(FALSE);
	if (data & 0x20)
	    digitalout_checkbox5->setChecked(TRUE);
	else
	    digitalout_checkbox5->setChecked(FALSE);
	if (data & 0x40)
	    digitalout_checkbox6->setChecked(TRUE);
	else
	    digitalout_checkbox6->setChecked(FALSE);
	if (data & 0x80)
	    digitalout_checkbox7->setChecked(TRUE);
	else
	    digitalout_checkbox7->setChecked(FALSE);
	///　デジタル出力の表示（16ビットタイマ2相パルス計数グループ）
	if (data & 0x10)
	    count16_checkbox4->setChecked(TRUE);
	else
	    count16_checkbox4->setChecked(FALSE);
	if (data & 0x20)
	    count16_checkbox5->setChecked(TRUE);
	else
	    count16_checkbox5->setChecked(FALSE);
	///　デジタル出力の表示（32ビットパルスカウンタグループ）
	if (data & 0x1)
	    count32_checkbox0->setChecked(TRUE);
	else
	    count32_checkbox0->setChecked(FALSE);
	if (data & 0x2)
	    count32_checkbox1->setChecked(TRUE);
	else
	    count32_checkbox1->setChecked(FALSE);
	if (data & 0x4)
	    count32_checkbox2->setChecked(TRUE);
	else
	    count32_checkbox2->setChecked(FALSE);
	if (data & 0x8)
	    count32_checkbox3->setChecked(TRUE);
	else
	    count32_checkbox3->setChecked(FALSE);
	///　パルスカウンタ値の読み出す
	USBM_PCReadCnt(handle, USBM_PC_ALL, count32_ary);
	///　パルスカウンタ値を表示する
	QString count0text;
	count0text.sprintf("%08X", (unsigned int) count32_ary[0]);
	count32_label0->setText(count0text);
	QString count1text;
	count1text.sprintf("%08X", (unsigned int) count32_ary[1]);
	count32_label1->setText(count1text);
	QString count2text;
	count2text.sprintf("%08X", (unsigned int) count32_ary[2]);
	count32_label2->setText(count2text);
	QString count3text;
	count3text.sprintf("%08X", (unsigned int) count32_ary[3]);
	count32_label3->setText(count3text);
	///　カウンタ値を更新する
	bord_input++;
    }
}
